/** 
 * VIEW    Javascript
 * 
 * @author  念, foresight@topnwise.com
 * @version 1.0, 2004/08/17
 * @since   1.0
 *
 * Copyright. (c) 2004 by Kyobo Life
 */

 /* =============================================================
  Function :  ޼ Factory
  Return   : N/A
  Usage    : 
================================================================= */
function CN_StringUtil() {
	this.isNull        		= isNull;
	this.isEmpty       		= isEmpty;
	this.containsChars 		= containsChars;
	this.containsCharsOnly 	= containsCharsOnly;
	this.isKorean			= isKorean;
	this.isEnglish			= isEnglish;
	this.isUpperCase		= isUpperCase;
	this.isLowerCase		= isLowerCase;
	this.isNumber			= isNumber;
	this.isAlphaNum			= isAlphaNum;
	this.isNumDash			= isNumDash;
	this.isNumComma			= isNumComma;
	this.isNumDot			= isNumDot;
	this.removeComma		= removeComma;
	this.isValidFormat		= isValidFormat;
	this.isValidEmail		= isValidEmail;
	this.isValidPhone		= isValidPhone;
	this.getByteLength		= getByteLength;
	this.trim				= trim;
	this.startTrim			= startTrim;
	this.endTrim			= endTrim;
	this.moneyStrForm		= moneyStrForm;
	this.commaCut			= commaCut;
	this.slashCut			= slashCut;
	this.slashAdd			= slashAdd;
}

/* =============================================================
  Function : Է° Null  ִ üũ
  Return   : N/A
  Usage    : 
================================================================= */
function isNull(input) {
    if (input.value == null || input.value == "") {
        return true;
    }
    return false;
}

/* =============================================================
  Function : Է° ̽ ̿ ǹ ִ  ִ üũ
  Return   : N/A
  Usage    : 
================================================================= */
function isEmpty(input) {
    if (input.value == null || input.value.replace(/ /gi,"") == "") {
        return true;
    }
    return false;
}

/* =============================================================
  Function : Է° Ư (chars) ִ üũ
  			 Ư ڸ     
  Return   : N/A
  Usage    : 
================================================================= */
function containsChars(input,chars) {
    for (var inx = 0; inx < input.value.length; inx++) {
       if (chars.indexOf(input.value.charAt(inx)) != -1)
           return true;
    }
    return false;
}

/* =============================================================
  Function : Է° Ư (chars) Ǿִ üũ
  			 Ư ڸ Ϸ   
  Return   : N/A
  Usage    : 
================================================================= */
function containsCharsOnly(input,chars) {
    for (var inx = 0; inx < input.value.length; inx++) {
       if (chars.indexOf(input.value.charAt(inx)) == -1)
           return false;
    }
    return true;
}

/* =============================================================
  Function : ѱ̿ ĳͰ  false
 			 ڳ    false
  Return   : N/A
  Usage    : 
================================================================= */
function isKorean(koreanChar) {
   koreanChar = koreanChar.split(' ').join('');

   //if ( koreanChar == null ) return false ;

   for(var i=0; i < koreanChar.length; i++){

     var c=koreanChar.charCodeAt(i);

     //( 0xAC00 <= c && c <= 0xD7A3 )   ѱ
     //( 0x3131 <= c && c <= 0x318E )  

     if( !( ( 0xAC00 <= c && c <= 0xD7A3 ) || ( 0x3131 <= c && c <= 0x318E ) ) ) {
        return false ;
     }
   }
   return true ;
}

/* =============================================================
  Function :  ̿ ĳͰ  false
  Return   : N/A
  Usage    : 
================================================================= */
function isEnglish(englishChar) {
    var englishChar = englishChar.split(' ').join('');

    // if ( englishChar == null ) return false ;

    for( var i=0; i < englishChar.length;i++){
       var c=englishChar.charCodeAt(i);
       if( !( (  0x61 <= c && c <= 0x7A ) || ( 0x41 <= c && c <= 0x5A ) ) ) {
        return false ;
       }
     }
    return true ;
}

/* =============================================================
  Function : Է° ĺ 빮 üũ
  Return   : N/A
  Usage    : 
================================================================= */

function isUpperCase(input) {
    var chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    return containsCharsOnly(input,chars);
}

/* =============================================================
  Function : Է° ĺ ҹ üũ
  Return   : N/A
  Usage    : 
================================================================= */
function isLowerCase(input) {
    var chars = "abcdefghijklmnopqrstuvwxyz";
    return containsCharsOnly(input,chars);
}

/* =============================================================
  Function : Է° ڸ ִ üũ
  Return   : N/A
  Usage    : 
================================================================= */
function isNumber(input) {
    var chars = "0123456789";
    return containsCharsOnly(input,chars);
}


/* =============================================================
  Function : Է° ĺ,ڷ Ǿִ üũ
  Return   : N/A
  Usage    : 
================================================================= */
function isAlphaNum(input) {
    var chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
    return containsCharsOnly(input,chars);
}

/* =============================================================
  Function : Է° ,(-) Ǿִ üũ
  Return   : N/A
  Usage    : 
================================================================= */
function isNumDash(input) {
    var chars = "-0123456789";
    return containsCharsOnly(input,chars);
}

/* =============================================================
  Function : Է° ,޸(,) Ǿִ üũ
  Return   : N/A
  Usage    : 
================================================================= */
function isNumComma(input) {
    var chars = ",0123456789";
    return containsCharsOnly(input,chars);
}

/* =============================================================
  Function : Է° ,޸(.) Ǿִ üũ
  Return   : N/A
  Usage    : 
================================================================= */
function isNumDot(input) {
    var chars = ".0123456789";
    return containsCharsOnly(input,chars);
}

/* =============================================================
  Function : Է° ,/ Ǿִ üũ
  Return   : N/A
  Usage    : 
================================================================= */
function isNumSlash(input) {
    var chars = "/0123456789";
    return containsCharsOnly(input,chars);
}

/* =============================================================
  Function : Է° ޸ ش.
  Return   : N/A
  Usage    : 
================================================================= */
function removeComma(input) {
    return input.value.replace(/,/gi,"");
}

/* =============================================================
  Function : isValidFormat
  Return   : N/A
  Usage    : Է° ڰ    üũ
             ڼ format  ڹٽũƮ 'regular expression' 
================================================================= */
function isValidFormat(input,format) {
    if (input.value.search(format) != -1) {
        return true; //ùٸ  
    }
    return false;
}

/* =============================================================
  Function : isValidEmail(input)
  Return   : N/A
  Usage    : Է° ̸  üũ
================================================================= */
function isValidEmail(input) {
//    var format = /^(\S+)@(\S+)\.([A-Za-z]+)$/;
    var format = /^((\w|[\-\.])+)@((\w|[\-\.])+)\.([A-Za-z]+)$/;
    return isValidFormat(input,format);
}

/* =============================================================
  Function : isValidPhone
  Return   : N/A
  Usage    : Է° ȭȣ (--) üũ
================================================================= */
function isValidPhone(input) {
    var format = /^(\d+)-(\d+)-(\d+)$/;
    return isValidFormat(input,format);
}

/* =============================================================
  Function : getByteLength(input)
  Return   : N/A
  Usage    : Է° Ʈ ̸ 
================================================================= */
function getByteLength(input) {
    var byteLength = 0;
    for (var inx = 0; inx < input.value.length; inx++) {
        var oneChar = escape(input.value.charAt(inx));
        if ( oneChar.length == 1 ) {
            byteLength ++;
        } else if (oneChar.indexOf("%u") != -1) {
            byteLength += 2;
        } else if (oneChar.indexOf("%") != -1) {
            byteLength += oneChar.length/3;
        }
    }
    return byteLength;
}

/* =============================================================
  Function : trim(str)
  Return   : N/A
  Usage    : Input Data  ó,  Space Ѵ.
================================================================= */
function trim(str)
{
  return endTrim(startTrim(str));
}

/* =============================================================
  Function : startTrim(str)  
  Return   : N/A
  Usage    : Input Data  ó Space Ѵ.
================================================================= */
function startTrim(str)
{
    var src = new String(str);
    var i, len = src.length;

    for(i = 0;i < len;i++)
    {
        if(src.charAt(i) != " " && src.charAt(i) != "\t")
        {
  	  break;
        }
    }
    return src.substring(i);
}

/* =============================================================
  Function : endTrim(str)  
  Return   : N/A
  Usage    : Input Data   Space Ѵ.
================================================================= */
function endTrim(str)
{
    var src = new String(str);
    var i, len = src.length;

    for(i = len-1;i > 0;i--)
    {
        if(src.charAt(i) != " " && src.charAt(i) != "\t")
        {
  	  break;
        }
    }
    return src.substring(0,i+1);
}

/* ===================================================================
	Function : moneyForm(obj)
	Return 	 :
	Usage 	 : form Ѱܹ޾ form ȯ  settingѴ.
=================================================================== */
function moneyForm(obj){
   	var num = obj.value;
	if(obj.value.length >= 4){
		// "$" and "," Է 
		re = /^\$|,/g;
		num = num.replace(re, "");

		fl = "";
		if(isNaN(num)){
			alert("ڴ   ϴ.");
			obj.value = "";
			return 0;
		}
		if(num==0) return num;

		if(num<0){
			num = num * (-1);
			fl = "-";
		}else{
			num = num * 1; //ó Է° 0 Ҷ ̰ Ѵ.
		}

		num = new String(num);
		temp = "";
		co = 3;
		num_len = num.length;
		while(num_len>0){
			num_len = num_len-co;
			if(num_len < 0){
				co = num_len + co;
				num_len = 0;
			}
			temp = "," + num.substr(num_len, co) + temp;
		}

		obj.value =  fl+temp.substr(1);
 	}
}

/* ===================================================================
	Function : moneyStrForm(str)
	Return 	 :
	Usage 	 : ڿ Է ޾ ȯ ڿ Ѱش.
=================================================================== */
function moneyStrForm(str){
	str = ""+str+"";
	var retValue = "";
	var number = new Number(str);

	//   "-" ϰ "," ó
	if( number < 0 ) str = str.substring(1);

	for(i=0; i<str.length; i++){
		if(i > 0 && (i%3)==0){
			retValue = str.charAt(str.length - i -1) + "," + retValue;
		}else{
			retValue = str.charAt(str.length - i -1) + retValue;
		}
	}

	//   "-" ش.
	if( number < 0 ) retValue = "-" + retValue;

	return retValue;
}

/* ===================================================================
	Function : commaCut(money)
	Return 	 :
	Usage 	 : Էµ ڿ ','  ڿ Ѵ.
=================================================================== */
function commaCut(money){
	if(money == '') return '';
	return money.split(",").join("");
}

/* ===================================================================
	Function : slashCut(date)
	Return 	 :
	Usage 	 : Էµ ¥ '/'  ڿ Ѵ. ('YYYY/MM/DD' -> 'YYYYMMDD')
=================================================================== */
function slashCut(date){
	return date.split("/").join("");
}

/* ===================================================================
	Function : slashAdd(date)
	Return 	 :
	Usage 	 : Էµ ¥ '/' ߰ ڿ Ѵ. ('YYYYMMDD' -> 'YYYY/MM/DD')
=================================================================== */
function slashAdd(date){
	return (date.substring(0,4) + '/' + date.substring(4,6) + '/' + date.substring(6));
}

// CN_StringUtil.js  ġ 
/* ===================================================================
	Function : funcMoneyToHan(obj, type)
 	Parameter : obj(Է¹޴ ʵ Obj), type(ȭ)
	Return    : String
=================================================================== */

hanNumber   = new Array ('', '', '', '', '', '', '', 'ĥ', '', '' );
fourFour    = new Array ('', '', '', '' );
fourDigit   = new Array ('', '', '', 'õ' );

function funcMoneyToHan(obj, type) {

	var returnVal = "";
	num = obj.value;
	str = "";
	strr = num.split(",");
	for (i=0; i<strr.length; i++){
		str += strr[i];
	}
	num = str;

	// ѱ۱ݾ ó
	delimiter = ' ';
	var endValue = '';
	var endZValue= '';

	bPos = 0; // , , 
	sPos = 0; // , , õ
	digit = 0;

	if (type==null){		// 
		bPos = 0; // , , 
		sPos = 0; // , , õ
		endValue = "";
		endZValue = "";
	} else if (type=='1'){	//
		bPos = 1; // , , 
		sPos = 0; // , , õ
		endValue = "";
		endZValue = " ";
	} else if (type=='2') {	//ʸ
		bPos = 1; // , , 
		sPos = 1; // , , õ
		endValue = "";
		endZValue = " ʸ";
	}

	szDigit = '';
	is_start = false;
	appendFF = false;
	len = num.length;
	szHan = '';

	for (i=len-1;i>=0;i--) {
		szDigit = num.substring(i,i+1);
		digit = parseInt(szDigit);

		if (digit!=0) {
			if (bPos!=0 && sPos==0) {
				if (is_start==true) szHan += delimiter;
				szHan += fourFour[bPos]; // , 
				appendFF=false;
			}
			if (bPos!=0 && appendFF==true) {
				if (is_start==true) szHan += delimiter;
				szHan += fourFour[bPos]; // , 
				appendFF=false;
			}
			if (sPos!=0) szHan += fourDigit[sPos]; // , , õ
			szHan += hanNumber[digit]; // , , 
			is_start=true;

		}
		else if (sPos==0 && bPos!=0) appendFF = true;
		sPos++;
		if (sPos%4==0) {
			sPos=0;
			bPos++;
			if (bPos>=4) return "(ʰ)";
		}
	}

	if (is_start==false)
	{
		rslt = '';
		returnVal = rslt + endZValue;

	}
	else
	{
		rslt = '';
		for(i = szHan.length - 1; i >= 0; i--) {
			rslt += szHan.substring(i, i + 1);
		}
		returnVal = rslt + endValue;
	}
	return returnVal;
}
